// simplest test program to output "Hello World!"
// on UART PORT 1 of MANGO64(S3C6410) Board

typedef unsigned long   u32;
typedef unsigned short  u16;
typedef unsigned char   u8;

typedef struct tag_UART_REGS
{
	volatile u32 rUlCon;
	volatile u32 rUCon;
	volatile u32 rUfCon;
	volatile u32 rUmCon;
	volatile u32 rUtrStat;
	volatile u32 rUerStat;
	volatile u32 rUfStat;
	volatile u32 rUmStat;
	volatile u32 rUtxh;
	volatile u32 rUrxh;
	volatile u32 rUbrDiv;
	volatile u32 rUdivSlot;
	volatile u32 rUintP;
	volatile u32 rUintSp;
	volatile u32 rUintM;
} UART_REGS;

#define UART_BASE    (0x7F005000)

#define UART_OFFSET  0x400

#define UART0_BASE   ((UART_REGS *)(UART_BASE))
#define UART1_BASE   ((UART_REGS *)(UART_BASE+UART_OFFSET))
#define UART2_BASE   ((UART_REGS *)(UART_BASE+UART_OFFSET*2))
#define UART3_BASE   ((UART_REGS *)(UART_BASE+UART_OFFSET*3))

UART_REGS * g_pUartDebugRegs = UART1_BASE;

char hello_world[] = "Hello World!\n\r";

int main(void)
{
    int i = 0;

    while (hello_world[i]) {
        while (!((*(volatile u32 *)(&g_pUartDebugRegs->rUtrStat)) & 0x2));
        (*(volatile u8 *)(&g_pUartDebugRegs->rUtxh)) = hello_world[i];
        i++;
    }

    return 0;
}
