#include "s3c_uart.h"
#include "io.h"

#define CONFIG_SYS_PCLK		66000000

static unsigned long base;

void mango_uart_init(unsigned long baseAddress, int baud)
{
    unsigned long reg;

    base = baseAddress;

    /* line configuratinon */
    reg = ULCON_8N1;
    writel(reg, base + ULCON);

    /* UART control */
    reg = UCON_CLK_PCLK | UCON_TXMODE_IRQ | UCON_RXMODE_IRQ;
    writel(reg, base + UCON);

    /* FIFO reset */
    reg = UFCON_TXTRG_16BYTES | UFCON_RXTRG_32BYTES | \
        UFCON_TXFIFO_RESET | UFCON_RXFIFO_RESET | UFCON_FIFO_ENABLE;
    writel(reg, base + UFCON);

    /* baud rate */
    reg = ((CONFIG_SYS_PCLK / baud / 16) - 1);
    writel(reg, base + UBRDIV);
}

int mango_uart_write(const char *buf, int len)
{
    int i;
    for (i = 0; i < len; ++i) {
        while (readl(base + UFSTAT) & UFSTAT_TXFIFO_FULL){;}
        writel(buf[i], base + UTXH);
    }

    return len;
}

