#include <io.h>
#include <s3c_gpio.h>
#include <s3c_timer.h>

void udelay(int usec)
{
    volatile unsigned long now, last, diff;

    now = readl(TIMER_BASE + TCNTO4);
    while (usec > 0) {
        last = now;
        now = readl(TIMER_BASE + TCNTO4);
        
        if (now > last)	/* timer has been reloaded */
        {
            diff = last + (TCNTB_MAX - now) + 1;
        }
        else
        {
            diff = last - now;
        }
        usec -= diff;
    }
}

void mdelay(int msec)
{
    udelay(msec * 1000);
}

void mango_timer_init(void)
{
    unsigned long reg;

    reg = TCFG0_DZLEN(0) | TCFG0_PSCLR1(33) | TCFG0_PSCLR0(1);
    writel(reg, TIMER_BASE + TCFG0);

    reg = TCFG1_DMA_NONE
          | (TCFG1_MUX_1_2 << TCFG1_MUX_SHIFTVAL_TIMER_4)
          | (TCFG1_MUX_1_2 << TCFG1_MUX_SHIFTVAL_TIMER_3)
          | (TCFG1_MUX_1_2 << TCFG1_MUX_SHIFTVAL_TIMER_2)
          | (TCFG1_MUX_1_2 << TCFG1_MUX_SHIFTVAL_TIMER_1)
          | (TCFG1_MUX_1_2 << TCFG1_MUX_SHIFTVAL_TIMER_0);
    writel(reg, TIMER_BASE + TCFG1);

    writel(TCNTB_MAX, TIMER_BASE + TCNTB4);

    reg = TCON_TIMER4_UPDATE;
    writel(reg, TIMER_BASE + TCON);

    reg = TCON_TIMER4_PERIODIC | TCON_TIMER4_START;
    writel(reg, TIMER_BASE + TCON);
}

