#ifndef __MANGO_BACKLIGHT_H
#define __MANGO_BACKLIGHT_H

#include <config.h>

#ifdef CONFIG_MANGO_24
#define MANGO_LCD_EN_GPIO_BANK      	S3C_GPIO_PORT_G
#define MANGO_LCD_EN_GPIO_PIN       	4
#define MANGO_LCD_BL_DIM_GPIO_BANK  	S3C_GPIO_PORT_B
#define MANGO_LCD_BL_DIM_GPIO_PIN   	3
#define MANGO_LCD_BL_DIM_TOUT_CHANNEL	3
#elif defined(CONFIG_MANGO_64)
#define MANGO_LCD_EN_GPIO_BANK      	S3C_GPIO_PORT_N
#define MANGO_LCD_EN_GPIO_PIN       	9
#define MANGO_LCD_BL_DIM_GPIO_BANK  	S3C_GPIO_PORT_F
#define MANGO_LCD_BL_DIM_GPIO_PIN   	15
#define MANGO_LCD_BL_DIM_TOUT_CHANNEL	1
#endif  /* CONFIG_MANGO_24 */

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */

void mango_backlight_init(void);
void mango_backlight_set_brightness(int percent);
void mango_backlight_stepup(void);
void mango_backlight_stepdown(void);

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif  /* __MANGO_BACKLIGHT_H */

