#include <mango_backlight.h>
#include <s3c_gpio.h>
#include <s3c_timer.h>

static int brightness = 100;

void mango_backlight_set_brightness(int percent)
{
    int tcmp;
    
    if (percent > 100)
        percent = 100;

    tcmp = percent * 10;
    if (percent == 100)
        --tcmp;

    mango_timer_stop(MANGO_LCD_BL_DIM_TOUT_CHANNEL);
    mango_timer_configure(MANGO_LCD_BL_DIM_TOUT_CHANNEL, 1000, tcmp, 0, 1);
    mango_timer_start(MANGO_LCD_BL_DIM_TOUT_CHANNEL);

    brightness = percent;
}

void mango_backlight_stepup(void)
{
    if (brightness == 100)
        return;

    mango_backlight_set_brightness(brightness + 10);
}

void mango_backlight_stepdown(void)
{
    if (!brightness)
        return;

    mango_backlight_set_brightness(brightness - 10);
}

void mango_backlight_init(void)
{
    mango_gpio_set_type(MANGO_LCD_EN_GPIO_BANK,
                        MANGO_LCD_EN_GPIO_PIN, S3C_GPIO_TYPE_OUTPUT);
    mango_gpio_set_val(MANGO_LCD_EN_GPIO_BANK,
                       MANGO_LCD_EN_GPIO_PIN, 1);   /* LCD PWREN - high */
    mango_timer_pwm_enable(MANGO_LCD_BL_DIM_TOUT_CHANNEL,
                           MANGO_LCD_BL_DIM_GPIO_BANK, MANGO_LCD_BL_DIM_GPIO_PIN, 1);
}

