#include <s3c_gpio.h>
#include <mango_button.h>

#ifdef CONFIG_MANGO_24
#define MANGO_GPIO_BUTTON_PORT	S3C_GPIO_PORT_F
#elif defined(CONFIG_MANGO_64)
#define MANGO_GPIO_BUTTON_PORT	S3C_GPIO_PORT_N
#endif

void mango_btn_init(void)
{
    mango_gpio_set_type(MANGO_GPIO_BUTTON_PORT, 0, S3C_GPIO_TYPE_INPUT);
    mango_gpio_set_type(MANGO_GPIO_BUTTON_PORT, 1, S3C_GPIO_TYPE_INPUT);
    mango_gpio_set_type(MANGO_GPIO_BUTTON_PORT, 2, S3C_GPIO_TYPE_INPUT);
    mango_gpio_set_type(MANGO_GPIO_BUTTON_PORT, 3, S3C_GPIO_TYPE_INPUT);
}

MANGO_BTN_STATE mango_btn_scan(MANGO_BTN_KEYCODE code)
{
    int val;

    mango_gpio_get_val(MANGO_GPIO_BUTTON_PORT, code, &val);

    if (!val) 	/* pressed */
        return MANGO_BTN_STATE_DOWN;
    else
        return MANGO_BTN_STATE_UP;
}
